/* optimizedgraph.h */
#ifndef __OPTIMIZED_GRAPH_H
#define __OPTIMIZED_GRAPH_H

#include "simplegraph.h"

#include "parameters.h"


/* Optimized nodes are essentially an int array.
  They have internal structure:
  serial (int) 
  NodeKey (int)
  NodeData (int)
  NodeMark (int)
  NumEdges (int)
  [Padding]
  For each edge:
	 EdgeKey (int)
	 EdgeData (int)
	 EdgeMark (int)
  For each edge:
	 Target index
	 [Padding]
*/
typedef int* ONode;

/*
Optimize an existing graph
*/
ONode* optimizeSimpleGraph(Node** arOriginalGraph, int numNodes);











#endif